sdpconevec.h File Reference

Each block of the SDPCone has two vectors of appropriate size. More...

Go to the source code of this file.

## Data Structures

struct | SDPConeVec_C
| Vector whose length corresponds to dimension of a block in a cone. More...

## Typedefs

typedef struct SDPConeVec_C | SDPConeVec
| SDPConeVec is a vector with the dimension of the block in the SDP cone.

## Functions

int | DSDPIndexCreate (int, DSDPIndex *)
| Allocate array for indices.
int | DSDPIndexDestroy (DSDPIndex *)
| Deallocate memory.
int | DSDPIndexInitialize (DSDPIndex *)
| Identifies sparsity in SDPConeVec.
int | DSDPIndexView (DSDPIndex)
| Print indices.
int | SDPConeVecAXPY (double, SDPConeVec, SDPConeVec)
| Add a multiple of X to Y.
int | SDPConeVecCopy (SDPConeVec, SDPConeVec)
| Copy v1 to v2.
int | SDPConeVecDot (SDPConeVec, SDPConeVec, double *)
| Inner product of two vectors.
int | SDPConeVecDuplicate (SDPConeVec, SDPConeVec *)
| Allocate another vector with the same structure as the first.
int | SDPConeVecNorm2 (SDPConeVec, double *)
| Compute the Euclidean norm.
int | SDPConeVecNormalize (SDPConeVec)
| Scale the vector to norm of 1.
int | SDPConeVecScale (double, SDPConeVec)
| Compute the Euclidean norm.
int | SDPConeVecSet (double, SDPConeVec)
| Set each element of vector to this number.
int | SDPConeVecView (SDPConeVec)
| Print the elements of the vector.
int | SDPConeVecZero (SDPConeVec)
| Zero the elements of the vector.

## Detailed Description

Each block of the SDPCone has two vectors of appropriate size.

Definition in file sdpconevec.h.

## Typedef Documentation

## SDPConeVec

struct SDPConeVec_C SDPConeVec

SDPConeVec is a vector with the dimension of the block in the SDP cone.

Definition at line 26 of file sdpconevec.h.

## Function Documentation

## DSDPIndexCreate()

int DSDPIndexCreate | ( | int | n,
|  | DSDPIndex * | IS
| ) |  |

extern

Allocate array for indices.

Parameters

  n | dimension of block or vector associated with it.
  IS | indices

Definition at line 248 of file sdpconevec.c.

Referenced by DSDPBlockSetup().

## DSDPIndexDestroy()

int DSDPIndexDestroy | ( | DSDPIndex * | IS | ) |

extern

Deallocate memory.

Parameters

  IS | indices

Definition at line 264 of file sdpconevec.c.

Referenced by DSDPBlockTakeDown().

## DSDPIndexInitialize()

int DSDPIndexInitialize | ( | DSDPIndex * | IS | ) |

extern

Identifies sparsity in SDPConeVec.

typedef struct { int *indx; } DSDPIndex;

Identifies sparsity in SDPConeVec.

Parameters

  IS | indices

Definition at line 234 of file sdpconevec.c.

Referenced by DSDPBlockInitialize().

## DSDPIndexView()

int DSDPIndexView | ( | DSDPIndex | IS | ) |

extern

Print indices.

Parameters

  IS | indices

Definition at line 279 of file sdpconevec.c.

## SDPConeVecAXPY()

int SDPConeVecAXPY | ( | double | alpha,
|  | SDPConeVec | x,
|  | SDPConeVec | y
| ) |  |

extern

Add a multiple of X to Y.

Parameters

  alpha | scalar
  x | a vec
  y | a vec

Definition at line 178 of file sdpconevec.c.

## SDPConeVecCopy()

int SDPConeVecCopy | ( | SDPConeVec | v1,
|  | SDPConeVec | v2
| ) |  |

extern

Copy v1 to v2.

Parameters

  v1 | source
  v2 | destination

Definition at line 103 of file sdpconevec.c.

## SDPConeVecDot()

int SDPConeVecDot | ( | SDPConeVec | V1,
|  | SDPConeVec | V2,
|  | double * | ans
| ) |  |

extern

Inner product of two vectors.

Parameters

  V1 | a vec
  V2 | a vec
  ans | the inner product

Definition at line 125 of file sdpconevec.c.

Referenced by DSDPDataMatCheck(), SDPConeComputeHessian(), and SDPConeComputeRHS().

## SDPConeVecDuplicate()

int SDPConeVecDuplicate | ( | SDPConeVec | V1,
|  | SDPConeVec * | V2
| ) |  |

extern

Allocate another vector with the same structure as the first.

Parameters

  V1 | source vector
  V2 | new vector

Definition at line 195 of file sdpconevec.c.

Referenced by DSDPBlockSetup(), DSDPFastLanczosSetup(), and DSDPRobustLanczosSetup().

## SDPConeVecNorm2()

int SDPConeVecNorm2 | ( | SDPConeVec | VV,
|  | double * | vnorm
| ) |  |

extern

Compute the Euclidean norm.

Parameters

  VV | a vec
  vnorm | its norm

Definition at line 143 of file sdpconevec.c.

Referenced by SDPConeVecNormalize().

## SDPConeVecNormalize()

int SDPConeVecNormalize | ( | SDPConeVec | V | ) |

extern

Scale the vector to norm of 1.

Parameters

  V | the vector

Definition at line 84 of file sdpconevec.c.

## SDPConeVecScale()

int SDPConeVecScale | ( | double | alpha,
|  | SDPConeVec | VV
| ) |  |

extern

Compute the Euclidean norm.

Parameters

  alpha | scalar.
  VV | a vec

Definition at line 161 of file sdpconevec.c.

Referenced by SDPConeVecNormalize().

## SDPConeVecSet()

int SDPConeVecSet | ( | double | alpha,
|  | SDPConeVec | V
| ) |  |

extern

Set each element of vector to this number.

Parameters

  alpha | scalar.
  V | a vec

Definition at line 211 of file sdpconevec.c.

Referenced by DSDPVMatCheck().

## SDPConeVecView()

int SDPConeVecView | ( | SDPConeVec | V | ) |

extern

Print the elements of the vector.

Parameters

  V | the vector

Definition at line 49 of file sdpconevec.c.

## SDPConeVecZero()

int SDPConeVecZero | ( | SDPConeVec | V | ) |

extern

Zero the elements of the vector.

Parameters

  V | the vector

Definition at line 67 of file sdpconevec.c.